diff --git a/parsing/syntaxerr.mli b/parsing/syntaxerr.mli
index 26ba712..6d44470 100644
--- a/parsing/syntaxerr.mli
+++ b/parsing/syntaxerr.mli
@@ -13,6 +13,12 @@
 (*                                                                        *)
 (**************************************************************************)
 
+(* language levels *)
+
+type language_t = English | Japanese
+val language : language_t
+val language_level : int
+
 (** Auxiliary type for reporting syntax errors
 
   {b Warning:} this module is unstable and part of
@@ -26,6 +32,8 @@ type error =
   | Not_expecting of Location.t * string
   | Applicative_path of Location.t
   | Variable_in_scope of Location.t * string
+  | Expert_exp of string * int * Location.t
+  | InfixOP0 of string * int * Location.t
   | Other of Location.t
   | Ill_formed_ast of Location.t * string
   | Invalid_package_type of Location.t * string
diff --git a/toplevel/toploop.ml b/toplevel/toploop.ml
index 6f0c12b..2178564 100644
--- a/toplevel/toploop.ml
+++ b/toplevel/toploop.ml
@@ -265,6 +265,26 @@ let add_directive name dir_fun dir_info =
   Hashtbl.add directive_table name dir_fun;
   Hashtbl.add directive_info_table name dir_info
 
+(* for type debugger *)
+
+(* structures input so far in the reverse order *)
+let rev_structures = ref []
+
+(* the last input phrase *)
+let last_phrase = ref (Ptop_def [])
+
+let structure_of_phrase phr = match phr with
+    Ptop_dir ({pdir_name = {txt = str}}) -> (print_string str; assert false)
+  | Ptop_def (str) -> str
+
+let rec rev_flatten structures acc = match structures with
+    [] -> acc
+  | structure :: rest -> rev_flatten rest (structure @ acc)
+
+(* cons_structure : structure -> structure list -> structure *)
+let cons_structure structure rev_structures =
+  rev_flatten (structure :: rev_structures) []
+
 (* Execute a toplevel phrase *)
 
 let execute_phrase print_outcome ppf phr =
@@ -315,6 +335,7 @@ let execute_phrase print_outcome ppf phr =
               Ophr_exception (exn, outv)
         in
         !print_out_phrase ppf out_phr;
+        rev_structures := sstr :: !rev_structures; (* for type debugger *)
         if Printexc.backtrace_status ()
         then begin
           match !backtrace with
@@ -374,7 +395,12 @@ let execute_phrase print_outcome ppf phr =
   try execute_phrase print_outcome ppf phr
   with exn ->
     Warnings.reset_fatal ();
-    raise exn
+    (* for type debugger *)
+    let last_str = structure_of_phrase !last_phrase in
+    let structure = cons_structure last_str !rev_structures in
+    Debug_main.launch exn structure Compmisc.initial_env;
+    false
+    (* raise exn *)
 
 (* Read and execute commands from a file, or from stdin if [name] is "". *)
 
@@ -407,6 +433,7 @@ let use_channel ppf ~wrap_in_module ic name filename =
       List.iter
         (fun ph ->
           let ph = preprocess_phrase ppf ph in
+          last_phrase := ph; (* for type debugger *)
           if not (execute_phrase !use_print_results ppf ph) then raise Exit)
         (if wrap_in_module then
            parse_mod_use_file name lb
@@ -611,6 +638,7 @@ let loop ppf =
       first_line := true;
       let phr = try !parse_toplevel_phrase lb with Exit -> raise PPerror in
       let phr = preprocess_phrase ppf phr  in
+      last_phrase := phr; (* for type debugger *)
       Env.reset_cache_toplevel ();
       ignore(execute_phrase true ppf phr)
     with
